
data Nat : Set where
  zero : Nat
  succ : Nat -> Nat

Fin : Nat -> Set
fz (n : Nat) : Fin (succ n)
fs (n : Nat) : Fin n -> Fin (succ n)

elimFin : (n : Nat) -> (x : Fin n) ->
	  (P : (m : Nat) -> Fin m -> Set) ->
	  ((m : Nat) -> P (succ m) fz) ->
	  ((m : Nat) -> (y : Fin m) -> P m y -> P (succ m) (fs y)) ->
	  P n x

caseFin : (n : Nat) -> (x : Fin n) ->
	  (P : (m : Nat) -> Fin m -> Set) ->
	  ((m : Nat) -> P (succ m) fz) ->
	  ((m : Nat) -> (y : Fin m) -> P (succ m) (fs y)) ->
	  P n x
caseFin n x P z s =
  elimFin n x {P} of
    (succ n) fz	    -> z n
    (succ n) (fs y) -> \_ -> s n y

data Lam (n : Nat) : Set where
  (@) : Lam n -> Lam n -> Lam n
  var : Fin n -> Lam n
  lam : Lam (succ n) -> Lam n

data Ty : Set where
  (-->)	: Ty -> Ty -> Ty
  nat	: Ty

Vec : Set -> Nat -> Set
nil (A : Set) : Vec A 0
(::) (A : Set)(n : Nat) : A -> Vec A n -> Vec A (succ n)

elimVec (A : Set) :
    (n : Nat) -> (xs : Vec A n) ->
    (P : (m : Nat) -> (ys : Vec A m) -> Set) ->
    P 0 ([] {A}) ->
    ((m : Nat) -> (x : A) -> (xs : Vec A m) -> P m xs -> P (succ m) (x :: xs)) ->
    P n xs

Env : Nat -> Set
Env n = Vec Ty n

hd (n : Nat) : Env (succ n) -> Ty
tl (n : Nat) : Env (succ n) -> Env n

lookup (n : Nat) : Env n -> Fin n -> Ty
lookup env i =
  ( elimFin n i {\sn i -> Env sn -> Ty} of
      (succ n) fz     -> \env -> hd env
      (succ n) (fs j) -> \rec env -> rec (tl env)
  ) env

Typing (n : Nat) : Env n -> Lam n -> Ty -> Set

varType (n : Nat) : (i : Fin n) -> (env : Env n) ->
		    Typing env (var i) (lookup env i)

funType (n : Nat) : (tau, sigma : Ty) -> (e : Lam (succ n)) ->
		    (env : Env n) ->
		    Typing (tau :: env) e sigma ->
		    Typing env (lam e) (tau --> sigma)

appType (n :: Nat) : ()

